#pragma once
#include "ChessArbiter.hpp"
#include "Game.hpp"
#include "HalfMove.hpp"
#include "board/BoardPanel.hpp"
#include "editor/EditorPanel.hpp"
#include "ochess.hpp"
#include <utility>
#include <wx/collpane.h>
#include <wx/splitter.h>
#include <wx/textctrl.h>

wxDECLARE_EVENT(REFRESH_TAB_TITLE, wxCommandEvent);
wxDECLARE_EVENT(GAME_CHANGE, wxCommandEvent);

class GameTab : public wxPanel, public TabInfos {
  EditorPanel *editor_panel;
  BoardPanel *board_panel;
  Game *game;
  void RefreshLabel();
  void OnRefreshTabTitle(wxCommandEvent &event);
  void OnGameChange(wxCommandEvent &event);

public:
  GameTab(wxFrame *parent, Game *game);
  void ApplyPreferences();
  void *GetGame() { return (game); }
  void *GetBase() { return (NULL); };
};
